#include "stdafx.h"
#include <iphlpapi.h>
#include "Helpers.h"


enum ePrivateUnicodeCodes
{
	pucFunction = 0xF000,
	pucClear,
	pucLeft,
	pucUp,
	pucDown,
	pucRight,
	pucHold, 
	pucRec,
	pucAlt,
	pucDial,
	pucSpeaker,
	pucPlus,
	pucMinus,
	pucMute,
	pucHangUp,
	pucList,
	pucMsg,
	pucSettings
};

int PhoneKey2Ordinal(int nPhoneKeyCode)
{
	int nCode = 0;
	switch(nPhoneKeyCode)
	{
	case pucFunction: nCode = 1; break;
	case pucClear: nCode = 2; break;
	case pucLeft: nCode = 3; break;
	case pucUp: nCode = 4; break;
	case pucDown: nCode = 5; break;
	case pucRight: nCode = 6; break;

	case pucList: nCode = 7; break;
	case pucMsg: nCode = 8; break;
	case pucSettings: nCode = 9; break;
	
	case pucHold: nCode = 10; break;
	case pucRec: nCode = 11; break;
	case pucAlt: nCode = 12; break;
	case pucDial: nCode = 13; break;
	
	case '1': nCode = 14; break;
	case '4': nCode = 15; break;
	case '7': nCode = 16; break;
	case '*': nCode = 17; break;
	case '2': nCode = 18; break;
	case '5': nCode = 19; break;
	case '8': nCode = 20; break;
	case '0': nCode = 21; break;
	case '3': nCode = 22; break;
	case '6': nCode = 23; break;
	case '9': nCode = 24; break;
	case '#': nCode = 25; break;
	
	case pucSpeaker: nCode = 26; break;
	case pucPlus: nCode = 27; break;
	case pucMinus: nCode = 28; break;
	case pucMute: nCode = 29; break;
	case pucHangUp: nCode = 0; break;
	default:
		nCode = -1;
	}
	return nCode;
}


CString Mac2String(const BYTE mac[6])
{
	CString str;
	TCHAR	buffer[3];
	int i;
    for (i = 0; i < 6; ++i) 
	{
        _stprintf (buffer, _T("%02X"), mac[i]);
		if (i>0) str += _T(".");
		str += buffer;
    }

	return str;
}

bool GetRemoteMACAddress(LPCTSTR strRemoteIP, BYTE mac[6])
{
	unsigned long nRemoteIP;
	PULONG		 pMacAddr;
	ULONG		 nAddressLength;
    DWORD		 dwRet;
	
	int nLen = _tcslen(strRemoteIP);
	char    *buff = new char[nLen+1];
	memset(buff, 0, nLen+1);
	wcstombs( buff, strRemoteIP, nLen);


	nRemoteIP = inet_addr(buff);
	if (!nRemoteIP) 
	{	// Wrong IP
	   return false;
	}
   	delete [] buff;

	// retrieve the remote MAC address
	nAddressLength = 6;
	pMacAddr = NULL;
	if (dwRet = SendARP(nRemoteIP, 0, (PULONG)mac, &nAddressLength))
	{
		LPVOID lpMsgBuf;
		if (!FormatMessage( 
			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
			FORMAT_MESSAGE_FROM_SYSTEM | 
			FORMAT_MESSAGE_IGNORE_INSERTS,
			NULL,
			dwRet,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
			(LPTSTR) &lpMsgBuf,
			0,
			NULL ))
		{
		   // Handle the error.
		   return false;
		} 

		// Process any inserts in lpMsgBuf.
		// ...

		// Display the string.
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, _T("Error"), MB_OK | MB_ICONINFORMATION );

		// Free the buffer.
		LocalFree( lpMsgBuf );



	   return false;
	}
      
	if (!nAddressLength)
	{
	   return false;
	}

	return true;
}

CString MBCS2String(const char *mbstr, size_t count)
{
	if (-1 == count) 
	{
		count = strlen(mbstr);
	}
	CString str;
	str.GetBuffer(count);
#ifdef _UNICODE	
	mbstowcs(str.GetBuffer(count), mbstr, count );
#else
	strncpy(str.GetBuffer(count), mbstr, count );
#endif
	str.ReleaseBuffer(count);
	return str;
}

char* String2MBCS(const CString& str)
{
	int	count = str.GetLength()+1;

	char* buff = new char[count];

#ifdef _UNICODE	
	wcstombs(buff, (LPCTSTR)str, count);
#else
	strncpy(buff, (LPCTSTR)str, count );
#endif
	return buff;
}

