// PXATesterDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PXATester.h"
#include "PXATesterDlg.h"
#include "PhoneDlg.h"
#include "DlgBarCodes.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPXATesterDlg dialog

CPXATesterDlg::CPXATesterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPXATesterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPXATesterDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}



void CPXATesterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPXATesterDlg)
	DDX_Control(pDX, IDC_TXT_LAST, m_txtLastTested);
	DDX_Control(pDX, IDC_ANIM_PHONESEARCH, m_ctrlPhoneSearch);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPXATesterDlg, CDialog)
	//{{AFX_MSG_MAP(CPXATesterDlg)
	ON_WM_CTLCOLOR()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPXATesterDlg message handlers

BOOL CPXATesterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_brushBk.CreateSolidBrush(RGB(0,128,192));


	LOGFONT lf;                        // Used to create the CFont.
	memset(&lf, 0, sizeof(LOGFONT));   // Clear out structure.
	CDC *pDC = GetDC();
	lf.lfHeight =  -MulDiv(15, pDC->GetDeviceCaps(LOGPIXELSY), 72);                  
	ReleaseDC(pDC);
	_tcscpy(lf.lfFaceName, _T("Arial"));    //    with face name "Arial".
	lf.lfCharSet = EASTEUROPE_CHARSET;
	m_font.CreateFontIndirect(&lf);    // Create the font.
	
//	SetFont(&m_font);
	GetDlgItem(IDC_LBL_CONNECTING)->SetFont(&m_font);
	GetDlgItem(IDCANCEL)->SetFont(&m_font);
	CString str;
	str.LoadString(IDS_WAITING_FOR_PHONE);
	GetDlgItem(IDC_LBL_CONNECTING)->SetWindowText(str);
	m_ctrlPhoneSearch.Open(IDR_AVI_PHONESEARCH);
	m_ctrlPhoneSearch.Play(0, -1, -1); 

	m_socListener.Create(TESTER_PORT_NUM, this);
	m_socListener.Listen();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

HBRUSH CPXATesterDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	switch (nCtlColor) 
	{
		case CTLCOLOR_BTN:
		case CTLCOLOR_STATIC:
			pDC->SetBkMode(TRANSPARENT);
			pDC->SetBkColor(RGB(0,128,192));
		case CTLCOLOR_DLG:
			return (HBRUSH)(m_brushBk.GetSafeHandle());

	default:
		return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPXATesterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPXATesterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

bool CPXATesterDlg::OnNewConnection()
{
	CDlgBarCodes dlgBC;
	if (IDOK == dlgBC.DoModal())
	{
		CPhoneDlg dlg(*this, dlgBC.GetSNPhone(), dlgBC.GetMAC1(), dlgBC.GetMAC2(), dlgBC.GetSNEnvelope());
		dlg.DoModal();
		m_txtLastTested.SetWindowText(dlg.GetInfo());
	}
	return true;
}

bool CPXATesterDlg::AcceptSocket(CSocket& soc)
{
	m_socListener.Accept(soc);
	return true;
}


void CPXATesterDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	SetCapture();
	m_pntCapture = point;
	ClientToScreen(&m_pntCapture);
	CRect rect;
	GetWindowRect(rect);
	m_pntWndTopLeft = rect.TopLeft();
	CDialog::OnLButtonDown(nFlags, point);
}

void CPXATesterDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	ReleaseCapture();
	CDialog::OnLButtonUp(nFlags, point);
}

void CPXATesterDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (GetCapture() == this)
	{
		TRACE(_T("pnt(%d, %d)\n"), point.x, point.y);
		CPoint pnt = point;
		ClientToScreen(&pnt);
		pnt = m_pntWndTopLeft + pnt - m_pntCapture;
		SetWindowPos( NULL, pnt.x, pnt.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER );
	}
	CDialog::OnMouseMove(nFlags, point);
}

BOOL CPXATesterDlg::PreTranslateMessage(MSG* pMsg) 
{
	return CDialog::PreTranslateMessage(pMsg);
}
