// DlgNetPhone.cpp : implementation file
//

#include "stdafx.h"
#include <Richedit.h>
#include "PXATester.h"
#include "Phone.h"
#include "PanelPhone.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "Helpers.h"


/////////////////////////////////////////////////////////////////////////////
// CPanelPhone dialog


CPanelPhone::CPanelPhone(CPhone& phone, CWnd* pParent /*=NULL*/)
	: CDialog(CPanelPhone::IDD, pParent),
	m_phone(phone)
{
	//{{AFX_DATA_INIT(CPanelPhone)
	//}}AFX_DATA_INIT
	m_brushBk.CreateSolidBrush(RGB(0,128,192));
	LOGFONT lf;                        // Used to create the CFont.
	memset(&lf, 0, sizeof(LOGFONT));   // Clear out structure.
	lf.lfHeight = 26;                  // Request a 20-pixel-high font
	_tcscpy(lf.lfFaceName, _T("Arial"));    //    with face name "Arial".
	lf.lfCharSet = EASTEUROPE_CHARSET;
	m_font.CreateFontIndirect(&lf);    // Create the font.
	

	memset(&lf, 0, sizeof(LOGFONT));   // Clear out structure.
	lf.lfHeight = 20;                  // Request a 20-pixel-high font
	_tcscpy(lf.lfFaceName, _T("Arial"));    //    with face name "Arial".
	lf.lfCharSet = EASTEUROPE_CHARSET;
	m_fontSmall.CreateFontIndirect(&lf);    // Create the font.
}

bool CPanelPhone::Create()
{
	if (!CDialog::Create(IDD))
		return false;
	SetFont(&m_font);
	GetDlgItem(IDC_QUESTION)->SetFont(&m_fontSmall);
	GetDlgItem(IDC_HEADER)->SetFont(&m_font);
	m_rtfPhone.SetFont(&m_fontSmall);
//	m_pict.SetBitmap(LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_PHONE)));
	m_pict.Init();
	// {\b bold \i Bold Italic \i0 Bold again}

	CString str;

	str.Format(IDS_PHONE_INFO, (LPCTSTR)m_phone.m_strMAC, (LPCTSTR)m_phone.m_strSN, (LPCTSTR)m_phone.m_strASN);

/*		
		= _T("{\\rtf\\ansi\\deff0{\\fonttbl{\\f0\\farial Tms Rmn\\fs12;}}{ \\plain ") ;
	str += _T(" \\b MAC: \\plain ") + m_phone.m_strMAC;
	str += _T(" \\b SN: \\plain ") + m_phone.m_strSN;
	str += _T(" \\b Obalka: \\plain ") + m_phone.m_strASN;
	str += _T("}");
*/

	m_rtfPhone.SetWindowText(str);



	ShowWindow(SW_SHOW);
	return TRUE;
}

void CPanelPhone::SetButtonStatus(int nButton, bool bChecked)
{
	m_pict.SetButtonStatus(nButton, bChecked);
}

void CPanelPhone::SetHeadingText(CString& str)
{
	m_ctrHeader.SetWindowText(str);
}

void CPanelPhone::SetQuestionText(CString& str)
{
	m_ctrlQuestion.SetWindowText(str);
}

void CPanelPhone::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPanelPhone)
	DDX_Control(pDX, IDC_RTF_PHONE, m_rtfPhone);
	DDX_Control(pDX, ID_BTN_YES, m_btnYes);
	DDX_Control(pDX, ID_BTN_NO, m_btnNo);
	DDX_Control(pDX, IDC_QUESTION, m_ctrlQuestion);
	DDX_Control(pDX, IDC_HEADER, m_ctrHeader);
	DDX_Control(pDX, IDC_PICT, m_pict);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPanelPhone, CDialog)
	//{{AFX_MSG_MAP(CPanelPhone)
	ON_WM_ERASEBKGND()
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(ID_BTN_YES, OnBtnYes)
	ON_BN_CLICKED(ID_BTN_NO, OnBtnNo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPanelPhone message handlers


BOOL CPanelPhone::OnEraseBkgnd(CDC* pDC) 
{
	// TODO: Add your message handler code here and/or call default
//	CRect rect;
//	GetClientRect(rect);
//	pDC->FillSolidRect(rect, RGB(1,1,1));
//	return TRUE;
	return CDialog::OnEraseBkgnd(pDC);
}


HBRUSH CPanelPhone::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	if (GetDlgItem(IDC_HEADER) == pWnd)
	{
		switch (nCtlColor) 
		{
//			case CTLCOLOR_BTN:
//			case CTLCOLOR_EDIT:
			case CTLCOLOR_STATIC:
				pDC->SetBkMode(TRANSPARENT);
				pDC->SetBkColor(RGB(0,128,192));
			case CTLCOLOR_DLG:
				return (HBRUSH)(m_brushBk.GetSafeHandle());

		default:
			return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
		}
	}
  return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
}

void CPanelPhone::OnBtnYes() 
{
	m_phone.OnTestFinish(true);
}

void CPanelPhone::OnBtnNo() 
{
	m_phone.OnTestFinish(false);
}



void CPanelPhone::TestKbd()
{
	CString str;
	str.LoadString(IDS_HEADING_TEST_KBD);
	SetHeadingText(str);
	str.LoadString(IDS_QUESTION_TEST_KBD);
	SetQuestionText(str);

	str.LoadString(IDS_TESTKBD_END);
	m_btnNo.SetWindowText(str);

	m_btnYes.ShowWindow(SW_HIDE);
	m_btnNo.ShowWindow(SW_SHOW);
}

void CPanelPhone::TestLED(int nTest)
{
	if (CPhone::tLED1red == nTest)
	{
		int i;
		for (i=0; i < PHONE_KEYS; i++)
		{
			m_pict.SetButtonStatus(i, true);
		}
	}

	CString str;
	str.LoadString(IDS_HEADING_TEST_LED);
	SetHeadingText(str);
	str.Empty();
	SetQuestionText(str);

	str.LoadString(IDS_YES);
	m_btnYes.SetWindowText(str);
	str.LoadString(IDS_NO);
	m_btnNo.SetWindowText(str);

	m_btnYes.ShowWindow(SW_SHOW);
	m_btnNo.ShowWindow(SW_SHOW);

	int nID, nLed;
	bool bRed, bGreen;
	switch (nTest)
	{
		case CPhone::tLED1red:		nLed = 0; bRed = true; bGreen = false; nID = IDS_QUESTION_TEST_LED1RED; break;
		case CPhone::tLED1green:	nLed = 0; bRed = false; bGreen = true; nID = IDS_QUESTION_TEST_LED1GREEN; break;
		case CPhone::tLED1off:		nLed = 0; bRed = false; bGreen = false; nID = IDS_QUESTION_TEST_LED1OFF; break;
		case CPhone::tLED2red:		nLed = 1; bRed = true; bGreen = false; nID = IDS_QUESTION_TEST_LED2RED; break;
		case CPhone::tLED2green:	nLed = 1; bRed = false; bGreen = true; nID = IDS_QUESTION_TEST_LED2GREEN; break;
		case CPhone::tLED2off:		nLed = 1; bRed = false; bGreen = false; nID = IDS_QUESTION_TEST_LED2OFF; break;
	}
	m_pict.SetLEDStatus(nLed, bRed, bGreen);

	str.LoadString(nID);
	SetQuestionText(str);
}


void CPanelPhone::TestDisplay(int nTest)
{

	CString str;
	str.LoadString(IDS_HEADING_TEST_DISPLAY);
	SetHeadingText(str);
	str.Empty();
	SetQuestionText(str);

	str.LoadString(IDS_YES);
	m_btnYes.SetWindowText(str);
	str.LoadString(IDS_NO);
	m_btnNo.SetWindowText(str);

	m_btnYes.ShowWindow(SW_SHOW);
	m_btnNo.ShowWindow(SW_SHOW);

	int nID, nDisplay;
	switch (nTest)
	{
		case CPhone::tDisplayFull:	nDisplay = 0; nID = IDS_QUESTION_TEST_DISPLAYFULL; break;
		case CPhone::tDisplayMesh:	nDisplay = 1; nID = IDS_QUESTION_TEST_DISPLAYMESH; break;
		case CPhone::tDisplayEmpty:	nDisplay = 2; nID = IDS_QUESTION_TEST_DISPLAYEMPTY; break;
	}
	m_pict.SetDisplayStatus(nDisplay);

	str.LoadString(nID);
	SetQuestionText(str);
}


void CPanelPhone::TestAudio(int nTest)
{
	CString str;
	str.LoadString(IDS_HEADING_TEST_AUDIO);
	SetHeadingText(str);
	str.Empty();
	SetQuestionText(str);

	str.LoadString(IDS_YES);
	m_btnYes.SetWindowText(str);
	str.LoadString(IDS_NO);
	m_btnNo.SetWindowText(str);

	m_btnYes.ShowWindow(SW_SHOW);
	m_btnNo.ShowWindow(SW_SHOW);

	int nID, nDevice;
	switch (nTest)
	{
		case CPhone::tHandsetSpeaker:	nDevice = 0; nID = IDS_QUESTION_TEST_HANDSETSPEAKER; break;
		case CPhone::tHandsetMic:		nDevice = 1; nID = IDS_QUESTION_TEST_HANDSETMIC; break;
		case CPhone::tPhoneSpeaker:		nDevice = 2; nID = IDS_QUESTION_TEST_PHONESPEAKER; break;
		case CPhone::tPhoneMic:			nDevice = 3; nID = IDS_QUESTION_TEST_PHONEMIC; break;
	}
	m_pict.ShowAudioDevice(nDevice);

	str.LoadString(nID);
	SetQuestionText(str);
}

void CPanelPhone::DisconnectPhone(bool bOK)
{
	CString str;
	str.Format(IDS_HEADING_TEST_FINISHED, Mac2String(m_phone.GetMAC()) );
	SetHeadingText(str);
	str.LoadString(bOK ? IDS_QUESTION_TEST_FINISHED_OK : IDS_QUESTION_TEST_FINISHED_WRONG);
}

void CPanelPhone::TestFinished(bool bOK)
{
	CString str;
	str.LoadString(IDS_HEADING_TEST_FINISHED_WRITING_PWD);
	SetHeadingText(str);
	str.Empty();
	SetQuestionText(str);
	m_pict.ShowAudioDevice(-1);
	m_pict.SetStatus(bOK ? 0:1);

	m_btnNo.ShowWindow(SW_HIDE);
	m_btnYes.ShowWindow(SW_HIDE);
}