// PhoneDlg.cpp : implementation file
//

#include "stdafx.h"

#include "PXATester.h"

#include "PXATesterDlg.h"
#include "PhoneDlg.h"
#include "Helpers.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPhoneDlg dialog


CPhoneDlg::CPhoneDlg(CPXATesterDlg& parent,
			const CString& strSNPhone, 
			const CString& strMAC1, 
			const CString& strMAC2,
			const CString& strSNEnvelope)
	: CDialog(CPhoneDlg::IDD, NULL), m_parent(parent)
{
	//{{AFX_DATA_INIT(CPhoneDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_strSNPhone = strSNPhone; 
	m_strMAC1 = strMAC1; 
	m_strMAC2 = strMAC2;
	m_strSNEnvelope = strSNEnvelope;

	m_brushBk.CreateSolidBrush(RGB(0,128,192));
	LOGFONT lf;                        // Used to create the CFont.
	memset(&lf, 0, sizeof(LOGFONT));   // Clear out structure.
	lf.lfHeight = 26;                  // Request a 20-pixel-high font
	_tcscpy(lf.lfFaceName, _T("Arial"));    //    with face name "Arial".
	lf.lfCharSet = EASTEUROPE_CHARSET;
	m_font.CreateFontIndirect(&lf);    // Create the font.
	

	memset(&lf, 0, sizeof(LOGFONT));   // Clear out structure.
	lf.lfHeight = 20;                  // Request a 20-pixel-high font
	_tcscpy(lf.lfFaceName, _T("Arial"));    //    with face name "Arial".
	lf.lfCharSet = EASTEUROPE_CHARSET;
	m_fontSmall.CreateFontIndirect(&lf);    // Create the font.

}


void CPhoneDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPhoneDlg)
	DDX_Control(pDX, IDC_RTF_PHONE, m_rtfPhone);
	DDX_Control(pDX, ID_BTN_YES, m_btnYes);
	DDX_Control(pDX, ID_BTN_NO, m_btnNo);
	DDX_Control(pDX, IDC_QUESTION, m_ctrlQuestion);
	DDX_Control(pDX, IDC_HEADER, m_ctrHeader);
	DDX_Control(pDX, IDC_PICT, m_pict);

	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPhoneDlg, CDialog)
	//{{AFX_MSG_MAP(CPhoneDlg)
	ON_WM_CTLCOLOR()
	ON_BN_CLICKED(ID_BTN_YES, OnBtnYes)
	ON_BN_CLICKED(ID_BTN_NO, OnBtnNo)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPhoneDlg message handlers

BOOL CPhoneDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_phone.SetDlg(this);
	m_parent.AcceptSocket((CSocket&)(m_phone));

	SetFont(&m_font);
	GetDlgItem(IDC_QUESTION)->SetFont(&m_fontSmall);
	GetDlgItem(IDC_HEADER)->SetFont(&m_font);

	{
		CRect rectPict, rectPI, rectQ, rectH, rectY, rectN, rectClient;
		GetDlgItem(IDC_RTF_PHONE)->GetWindowRect(rectPI);
		GetDlgItem(IDC_QUESTION)->GetWindowRect(rectQ);
		GetDlgItem(IDC_HEADER)->GetWindowRect(rectH);
		GetDlgItem(ID_BTN_YES)->GetWindowRect(rectY);
		GetDlgItem(ID_BTN_NO)->GetWindowRect(rectN);

		m_pict.GetWindowRect(rectPict);
		
		ScreenToClient(rectPI);
		ScreenToClient(rectQ);
		ScreenToClient(rectH);
		ScreenToClient(rectY);
		ScreenToClient(rectN);
		ScreenToClient(rectPict);
			
		rectPict.OffsetRect(0, -rectPict.top + rectPI.bottom);
		rectPI.right = rectPict.right;
		
		rectH.OffsetRect(0, -rectH.top + rectPict.bottom);
		rectH.right = rectPict.right;

		rectQ.OffsetRect(0, -rectQ.top + rectH.bottom);
		
		rectN.OffsetRect(
			-rectN.left + rectPict.right - rectN.Width(), 
			-rectN.top + rectQ.bottom - rectN.Height());

		rectY.OffsetRect(
			-rectY.left + rectN.left - rectY.Width() - 10, 
			-rectY.top + rectQ.bottom - rectY.Height());

		rectQ.right = rectY.left - 10;

		GetDlgItem(IDC_RTF_PHONE)->MoveWindow(rectPI);
		m_pict.MoveWindow(rectPict);
		GetDlgItem(IDC_QUESTION)->MoveWindow(rectQ);
		GetDlgItem(IDC_HEADER)->MoveWindow(rectH);
		GetDlgItem(ID_BTN_YES)->MoveWindow(rectY);
		GetDlgItem(ID_BTN_NO)->MoveWindow(rectN);

	
		rectClient.left = 0;
		rectClient.top = 0; 
		rectClient.right = rectN.right + rectPI.left;
		rectClient.bottom = rectN.bottom + rectPI.top;

		CalcWindowRect(rectClient);
		
		CRect rectDesktop;
		GetDesktopWindow()->GetWindowRect(rectDesktop);
		rectClient.OffsetRect((rectDesktop.Width()-rectClient.Width()) / 2, (rectDesktop.Height()-rectClient.Height()) / 2);
		MoveWindow(rectClient);
	}



	m_rtfPhone.SetBackgroundColor(FALSE, RGB(0,128,192));

//	m_pict.SetBitmap(LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_PHONE)));
	m_pict.Init();
	// {\b bold \i Bold Italic \i0 Bold again}
	if (!m_phone.OnConnected())
	{
		m_phone.Close();
		EndDialog(0);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPhoneDlg::SetTitleText(CString& str)
{
	m_rtfPhone.SetWindowText(str);
}

void CPhoneDlg::SetButtonStatus(int nButton, bool bChecked)
{
	m_pict.SetButtonStatus(nButton, bChecked);
}

void CPhoneDlg::SetHeadingText(CString& str)
{
	m_ctrHeader.SetWindowText(str);
}

void CPhoneDlg::SetQuestionText(CString& str)
{
	m_ctrlQuestion.SetWindowText(str);
}

HBRUSH CPhoneDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	if (GetDlgItem(IDC_HEADER) == pWnd)
	{
		switch (nCtlColor) 
		{
//			case CTLCOLOR_BTN:
//			case CTLCOLOR_EDIT:
			case CTLCOLOR_STATIC:
				pDC->SetBkMode(TRANSPARENT);
				pDC->SetBkColor(RGB(0,128,192));
			case CTLCOLOR_DLG:
				return (HBRUSH)(m_brushBk.GetSafeHandle());

		default:
			return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
		}
	}
  return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
}


void CPhoneDlg::OnBtnYes() 
{
	m_phone.OnTestFinish(true);
}

void CPhoneDlg::OnBtnNo() 
{
	m_phone.OnTestFinish(false);
}

CString CPhoneDlg::GetInfo() const
{
	CString str;
	str.LoadString(m_phone.IsPhoneOK() ? IDS_PHONE_OK: IDS_PHONE_WRONG);
	return m_phone.m_strMAC + _T(" ") + str;
}


void CPhoneDlg::TestKbd()
{
	SetButtonsStatus(false);

	CString str;
	str.LoadString(IDS_HEADING_TEST_KBD);
	SetHeadingText(str);
	str.LoadString(IDS_QUESTION_TEST_KBD);
	SetQuestionText(str);

	str.LoadString(IDS_TESTKBD_END);
	m_btnNo.SetWindowText(str);

	m_btnYes.ShowWindow(SW_HIDE);
	m_btnNo.ShowWindow(SW_SHOW);
}

void CPhoneDlg::SetButtonsStatus(bool bOK)
{
	int i;
	for (i=0; i < PHONE_KEYS; i++)
	{
		m_pict.SetButtonStatus(i, bOK);
	}
}

void CPhoneDlg::TestLED(int nTest)
{
	CString str;
	str.LoadString(IDS_HEADING_TEST_LED);
	SetHeadingText(str);
	str.Empty();
	SetQuestionText(str);

	str.LoadString(IDS_YES);
	m_btnYes.SetWindowText(str);
	str.LoadString(IDS_NO);
	m_btnNo.SetWindowText(str);

	m_btnYes.ShowWindow(SW_SHOW);
	m_btnNo.ShowWindow(SW_SHOW);

	int nID, nLed;
	bool bRed, bGreen;
	switch (nTest)
	{
		case CPhone::tLED1red:		nLed = 0; bRed = true; bGreen = false; nID = IDS_QUESTION_TEST_LED1RED; break;
		case CPhone::tLED1green:	nLed = 0; bRed = false; bGreen = true; nID = IDS_QUESTION_TEST_LED1GREEN; break;
		case CPhone::tLED1off:		nLed = 0; bRed = false; bGreen = false; nID = IDS_QUESTION_TEST_LED1OFF; break;
		case CPhone::tLED2red:		nLed = 1; bRed = true; bGreen = false; nID = IDS_QUESTION_TEST_LED2RED; break;
		case CPhone::tLED2green:	nLed = 1; bRed = false; bGreen = true; nID = IDS_QUESTION_TEST_LED2GREEN; break;
		case CPhone::tLED2off:		nLed = 1; bRed = false; bGreen = false; nID = IDS_QUESTION_TEST_LED2OFF; break;
	}
	m_pict.SetLEDStatus(nLed, bRed, bGreen);

	str.LoadString(nID);
	SetQuestionText(str);
}


void CPhoneDlg::TestDisplay(int nTest)
{

	CString str;
	str.LoadString(IDS_HEADING_TEST_DISPLAY);
	SetHeadingText(str);
	str.Empty();
	SetQuestionText(str);

	str.LoadString(IDS_YES);
	m_btnYes.SetWindowText(str);
	str.LoadString(IDS_NO);
	m_btnNo.SetWindowText(str);

	m_btnYes.ShowWindow(SW_SHOW);
	m_btnNo.ShowWindow(SW_SHOW);

	int nID, nDisplay;
	switch (nTest)
	{
		case CPhone::tDisplayFull:	nDisplay = 0; nID = IDS_QUESTION_TEST_DISPLAYFULL; break;
		case CPhone::tDisplayMesh:	nDisplay = 1; nID = IDS_QUESTION_TEST_DISPLAYMESH; break;
		case CPhone::tDisplayEmpty:	nDisplay = 2; nID = IDS_QUESTION_TEST_DISPLAYEMPTY; break;
	}
	m_pict.SetDisplayStatus(nDisplay);

	str.LoadString(nID);
	SetQuestionText(str);
}


void CPhoneDlg::TestAudio(int nTest)
{
	CString str;
	str.LoadString(IDS_HEADING_TEST_AUDIO);
	SetHeadingText(str);
	str.Empty();
	SetQuestionText(str);

	str.LoadString(IDS_YES);
	m_btnYes.SetWindowText(str);
	str.LoadString(IDS_NO);
	m_btnNo.SetWindowText(str);

	m_btnYes.ShowWindow(SW_SHOW);
	m_btnNo.ShowWindow(SW_SHOW);

	int nID, nDevice;
	switch (nTest)
	{
		case CPhone::tHandsetSpeaker:	nDevice = 0; nID = IDS_QUESTION_TEST_HANDSETSPEAKER; break;
		case CPhone::tHandsetMic:		nDevice = 1; nID = IDS_QUESTION_TEST_HANDSETMIC; break;
		case CPhone::tPhoneSpeaker:		nDevice = 2; nID = IDS_QUESTION_TEST_PHONESPEAKER; break;
		case CPhone::tPhoneMic:			nDevice = 3; nID = IDS_QUESTION_TEST_PHONEMIC; break;
	}
	m_pict.ShowAudioDevice(nDevice);

	str.LoadString(nID);
	SetQuestionText(str);
}

void CPhoneDlg::DisconnectPhone(bool bOK)
{
	CString str;
	str.LoadString(IDS_HEADING_TEST_FINISHED);
	SetHeadingText(str);
	m_pict.SetStatus(bOK ? 0:1);
}

void CPhoneDlg::TestFinished()
{
	CString str;
	str.LoadString(IDS_HEADING_TEST_FINISHED_WRITING_PWD);
	SetHeadingText(str);
	str.Empty();
	SetQuestionText(str);
	m_pict.ShowAudioDevice(-1);

	m_btnNo.ShowWindow(SW_HIDE);
	m_btnYes.ShowWindow(SW_HIDE);
}


void CPhoneDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	SetCapture();
	m_pntCapture = point;
	ClientToScreen(&m_pntCapture);
	CRect rect;
	GetWindowRect(rect);
	m_pntWndTopLeft = rect.TopLeft();
	CDialog::OnLButtonDown(nFlags, point);
}

void CPhoneDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	ReleaseCapture();
	CDialog::OnLButtonUp(nFlags, point);
}

void CPhoneDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (GetCapture() == this)
	{
		TRACE(_T("pnt(%d, %d)\n"), point.x, point.y);
		CPoint pnt = point;
		ClientToScreen(&pnt);
		pnt = m_pntWndTopLeft + pnt - m_pntCapture;
		SetWindowPos( NULL, pnt.x, pnt.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER );
	}
	CDialog::OnMouseMove(nFlags, point);
}
