#if !defined(AFX_PHONEDLG_H__2A5F916C_F0BB_4F86_8CD4_A1A158070541__INCLUDED_)
#define AFX_PHONEDLG_H__2A5F916C_F0BB_4F86_8CD4_A1A158070541__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PhoneDlg.h : header file
//
#include "SocketPhone.h"
#include "PhonePicture.h"

#include "Phone.h"

/////////////////////////////////////////////////////////////////////////////
// CPhoneDlg dialog
class CPXATesterDlg;
class CPhoneDlg : public CDialog
{
// Construction
public:
	CPhoneDlg(CPXATesterDlg& parent,
			const CString& strSNPhone, 
			const CString& strMAC1, 
			const CString& strMAC2,
			const CString& strSNEnvelope);

	const CString& GetMAC1() const { return m_strMAC1; }
	const CString& GetMAC2() const { return m_strMAC2; }
	const CString& GetSNPhone() const	{ return m_strSNPhone; }
	const CString& GetSNEnvelope() const	{ return m_strSNEnvelope; }


	CString GetInfo() const;
	void SetButtonsStatus(bool bOK);

	void TestKbd();
	void TestLED(int nTest);
	void TestDisplay(int nTest);
	void TestAudio(int nTest);
	void TestFinished();
	void DisconnectPhone(bool bOK);

	void SetTitleText(CString& str);
	void SetHeadingText(CString& str);
	void SetQuestionText(CString& str);
	void SetButtonStatus(int nButton, bool bChecked);

// Dialog Data
	//{{AFX_DATA(CPhoneDlg)
	enum { IDD = IDD_DLG_PHONE };
	CRichEditCtrl	m_rtfPhone;
	CButton	m_btnYes;
	CButton	m_btnNo;
	CStatic	m_ctrlQuestion;
	CStatic	m_ctrHeader;
	CPhonePicture	m_pict;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPhoneDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CPhoneDlg)
	virtual BOOL OnInitDialog();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnBtnYes();
	afx_msg void OnBtnNo();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CPhone			m_phone;
	CPXATesterDlg&  m_parent;

	CFont			m_font;
	CFont			m_fontSmall;
	CBrush			m_brushBk;

	CPoint			m_pntCapture;
	CPoint			m_pntWndTopLeft;

	CString m_strSNPhone; 
	CString m_strMAC1; 
	CString m_strMAC2;
	CString m_strSNEnvelope;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PHONEDLG_H__2A5F916C_F0BB_4F86_8CD4_A1A158070541__INCLUDED_)
