// SocketPhone.h : header file
//

#ifndef _SOCKETPHONE_H_
#define _SOCKETPHONE_H_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#define MAX_BUFF 1024

class CSocketPhone : public CAsyncSocket
{
	// Attributes
public:
	virtual bool OnConnected() = 0;
	virtual bool OnData(LPCTSTR lpData) = 0;
	virtual bool OnDisconnected() = 0;

// Operations
public:
	CSocketPhone();
	virtual ~CSocketPhone();
	bool Send(const CString& str);

// Overrides
public:
	DWORD	m_dwLastRead;
	char	m_sendBuff[MAX_BUFF+4];
	int		m_nSendDataLen;
	int		m_nBytesSent;

	char	m_recvBuff[MAX_BUFF+4];
	int		m_nRecvDataLen;
	int		m_nBytesRecv;
	BOOL	m_bReadDataLength;
	
	void AsyncSendBuff(void* lpBuf, int nBufLen);
	void StartChecker();
	void SuspendChecker();
	void ResumeChecker();
	

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSocketPhone)
	public:
	virtual void OnConnect( int nErrorCode );
	virtual void OnClose(int nErrorCode);
	virtual void OnReceive(int nErrorCode);
	virtual void OnSend(int nErrorCode);
	virtual int Receive(void* lpBuf, int nBufLen, int nFlags = 0);
	virtual int Send(const void* lpBuf, int nBufLen, int nFlags = 0);
	//}}AFX_VIRTUAL

	// Generated message map functions
	//{{AFX_MSG(CSocketPhone)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

// Implementation
protected:
	void		DoAsyncSendBuff();
private:
	static UINT ConnectionTester( LPVOID pParam );

private:
	HWND			m_hSocketWindow;
	bool			m_bConnected;
	bool			m_bSuspended;

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // _SOCKETPHONE_H_
